//****************************************************************************
//	aisa38w.pas
//
//	aISA-P38
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/27
//
//****************************************************************************

unit aisa38w;

interface

uses
	Windows;

{ Errors }

const
	AISA38_SUCCESS							= 0;	 { ُȂ }
	AISA38_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA38_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA38_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA38_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA38_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA38_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA38_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA38_PORT_0	= 0;
	AISA38_PORT_1	= 1;
  AISA38_PORT_2	= 2;
	AISA38_PORT_3	= 3;


{ Miscellaneous }

const
	AISA38_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA38_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA38_DLL_NAME = 'aisa38.dll';		{ DLL }

function Aisa38wDllOpen: Boolean;			{ DLL [h }
function Aisa38wDllClose: Boolean;		{ DLL A[h }


const
	AISA38_SLOT_AUTO = $ffff;

{ aISA-P38 DLL,Driver̃o[Wԍ擾 }
function Aisa38wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P38̎gp錾 }
function Aisa38wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P38̎gpJ }
function Aisa38wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA38_MAX_MEM	=	 9;
		AISA38_MAX_IO		= 20;
		AISA38_MAX_IRQ	=	 7;
		AISA38_MAX_DMA	=	 7;

type
		TAISA38RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA38_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA38_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA38_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA38_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA38_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA38_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA38_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA38_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA38_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA38RESOURCE = ^TAISA38RESOURCE;

{ \[X擾 }
function Aisa38wGetResource(wLogSlot: Word;  pResInfo: PAISA38RESOURCE): Boolean;

{ Cӂ̃|[gփf[^o }
function Aisa38wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;

{ aISA-P38̃G[R[h }
function Aisa38wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa38GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa38Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa38Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa38GetResource = function(wLogSlot: WORD; res: PAISA38RESOURCE):	BOOL; stdcall;
	TAisa38OutPort = function(wLogSlot: WORD; dwLogPort: DWORD; bOutValue: BYTE): BOOL; stdcall;
	TAisa38GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa38wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa38GetVersion: TAisa38GetVersion;
	pAisa38Create: TAisa38Create;
	pAisa38Close: TAisa38Close;
	pAisa38GetResource: TAisa38GetResource;
	pAisa38OutPort: TAisa38OutPort;
	pAisa38GetLastError: TAisa38GetLastError;


//****************************************************************************
// @\			aisa38.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa38wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA38_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa38wGetDllExportFunc = False then
  begin
       Aisa38wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa38.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa38wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P38 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa38wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa38GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P38̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa38wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa38Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P38̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa38wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa38Close(wLogSlot);
end;

//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa38wGetResource(wLogSlot: Word;  pResInfo: PAISA38RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa38GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// @\			Cӂ̃|[gփf[^o
// 			wLogSlot	--- o͂foCX
//					dwPort		--- o͂|[g
//					bOutValue --- o͂f[^
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa38wOutPort(wLogSlot: Word; dwPort: DWord; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa38OutPort(wLogSlot, dwPort, bOutValue);
end;

//****************************************************************************
// @\			aISA-P38̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa38wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA38_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa38GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa38wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa38GetVersion ̃AhX擾
	pAisa38GetVersion := GetProcAddress(hDLL, 'Aisa38GetVersion');
	if @pAisa38GetVersion = nil then Exit;

	// Aisa38Create ̃AhX擾
	pAisa38Create := GetProcAddress(hDLL, 'Aisa38Create');
	if @pAisa38Create = nil then Exit;

	// Aisa38Close ̃AhX擾
	pAisa38Close := GetProcAddress(hDLL, 'Aisa38Close');
	if @pAisa38Close = nil then Exit;

	// Aisa38GetResource ̃AhX擾
	pAisa38GetResource := GetProcAddress(hDLL, 'Aisa38GetResource');
	if @pAisa38GetResource = nil then Exit;

	// Aisa38OutPort ̃AhX擾
	pAisa38OutPort := GetProcAddress(hDLL, 'Aisa38OutPort');
	if @pAisa38OutPort = nil then Exit;

	// Aisa38GetLastError ̃AhX擾
	pAisa38GetLastError := GetProcAddress(hDLL, 'Aisa38GetLastError');
	if @pAisa38GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

