Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa38.bas
'
'       AISA-R38 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Errors

Global Const AISA38_SUCCESS = 0                ' Successfully proccessed
Global Const AISA38_ERR_SYSTEM = 1             ' Call GetLastError()
Global Const AISA38_ERR_NO_DEVICE = 2          ' No card
Global Const AISA38_ERR_IN_USE = 3             ' Device is in use
Global Const AISA38_ERR_INVALID_SLOT = 4       ' Invalid logical slot
Global Const AISA38_ERR_RESOURCE = 5           ' Resource exhaustion
Global Const AISA38_ERR_INVALID_PORT = 6       ' Invalid port
Global Const AISA38_ERR_INVALID_ARGUMENT = 7   ' Invalid port

' Port numbers

Global Const AISA38_PORT_0 = 0
Global Const AISA38_PORT_1 = 1
Global Const AISA38_PORT_2 = 2
Global Const AISA38_PORT_3 = 3


' Miscsellaneous

Global Const AISA38_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA38_SLOT_AUTO = &HFFFF

' Resource infomation structure

Global Const AISA38_MAX_MEM = 9
Global Const AISA38_MAX_IO = 20
Global Const AISA38_MAX_IRQ = 7
Global Const AISA38_MAX_DMA = 7

Type AISA38RESOURCE
    dwNumMemWindows As Long                         ' Not used
    dwMemBase(1 To AISA38_MAX_MEM) As Long          ' Not used
    dwMemLength(1 To AISA38_MAX_MEM) As Long        ' Not used
    dwMemAttrib(1 To AISA38_MAX_MEM) As Long        ' Not used
    dwNumIOPorts As Long                            ' Num IO ports
    dwIOPortBase(1 To AISA38_MAX_IO) As Long        ' I/O port base
    dwIOPortLength(1 To AISA38_MAX_IO) As Long      ' I/O port length
    dwNumIRQs As Long                               ' Num IRQ info
    dwIRQRegisters(1 To AISA38_MAX_IRQ) As Long     ' IRQ list
    dwIRQAttrib(1 To AISA38_MAX_IRQ) As Long        ' IRQ Attrib list
    dwNumDMAs As Long                               ' Not used
    dwDMALst(1 To AISA38_MAX_DMA) As Long           ' Not used
    dwDMAAttrib(1 To AISA38_MAX_DMA) As Long        ' Not used
    dwReserved1(1 To 3) As Long                     ' Not used
End Type

Declare Function Aisa38GetVersion Lib "aisa38" (lpdwDllVer As Long, lpdwDrvVer As Long) As Long
Declare Function Aisa38Create Lib "aisa38" (lpwLogSlot As Integer) As Long
Declare Function Aisa38Close Lib "aisa38" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa38GetResource Lib "aisa38" (ByVal wLogSlot As Integer, lpres As AISA38RESOURCE) As Long
Declare Function Aisa38OutPort Lib "aisa38" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Declare Function Aisa38GetLastError Lib "aisa38" (ByVal wLogSlot As Integer) As Long
