Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa38s.frm
'*
'* aISA-R38
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/27
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************
Option Explicit

Private Const szName = "aISA-R38"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long                ' DLL̃o[W
    Dim dwDrvVer As Long                ' Driver̃o[W
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim OutValue As Byte                ' o̓f[^
    Dim ri As AISA38RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa38.dll ̎gp錾
    If Aisa38wDllOpen() = False Then
        ErrorMessage (AISA38_SLOT_AUTO)
        Exit Sub                ' aisa38.dll ̃[hɎs܂B
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa38wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-R38DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA38_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-R38̎gp錾
    wLogSlot = AISA38_SLOT_AUTO     ' gp̃foCXT܂B
    bResult = Aisa38wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA38_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-R38 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa38wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szName + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 0ɔCӂ̃f[^o
    ' &HAA -> 10101010
    OutValue = &HAA

    If Aisa38wOutPort(wLogSlot, AISA38_PORT_0, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 0փf[^o" + Chr(10) + _
             "Port 0 Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-R38̎gpJ
    If Aisa38wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-R38 Closed")

'---------------------------------------------------------------------------
    ' aisa38.dll̎gpJ
    If Aisa38wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa38.dll ̃A[hɎs܂B
    End If

End Sub

'---------------------------------------------------------------------------
' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa38wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA38_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA38_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-R38 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
